import { initCanvas } from "./canvas.js";
import { queueflush, scheduledDom } from "./scheduler.js";
import { mergeOptions } from "./options.js";
const HOOK = "__VUE_DEVTOOLS_GLOBAL_HOOK__";
function VueChangeMarker(options) {
  if (options) mergeOptions(options);
  initCanvas();
  registerDevtoolsHook();
}
function emit(event, ...payload) {
  var _a;
  if (event === "component:updated") {
    const updatedInstance = payload[3];
    const type = (_a = updatedInstance.vnode.type) == null ? void 0 : _a.toString();
    if (type === "Symbol(v-fgt)") return;
    const el = updatedInstance.vnode.el;
    if (!(el instanceof HTMLElement)) return;
    scheduledDom.push({ dom: el, updatedInstance });
    queueflush();
  }
}
function registerDevtoolsHook() {
  var _a;
  if (((_a = window[HOOK]) == null ? void 0 : _a.id) !== "vue-change-marker") {
    const oldEmit = window[HOOK].emit;
    window[HOOK].emit = function(...args) {
      oldEmit.call(window[HOOK], ...args);
      emit(...args);
    };
  }
  if (!window[HOOK]) {
    window[HOOK] = { id: "vue-change-marker", emit };
  }
}
export {
  VueChangeMarker
};
